(use testeez uuid-lib)
;; This test set was adapted for testeez from uuid-lib-test.scm

(testeez
 "uuid-lib"
 (test/eqv  "uuid?"
	      (uuid? (uuid-generate))
	      #t)
 (test/eqv  "uuid-null? (1)"
	      (uuid-null? (uuid-generate))
	      #f)
 (test/eqv  "uuid-null? (2)"
	      (uuid-null? (uuid-clear! (uuid-generate)))
	      #t)
 (test/eqv  "A uuid is equal to, less than or equal to and greater than or equal to itself"
	      (let ((tuuid (uuid-generate)))
		(and (uuid=? tuuid tuuid) (uuid<=? tuuid tuuid) (uuid>=? tuuid tuuid)))
	      #t)
 (test/eqv  "Time uuids and random uuids"
	      (let ((tuuid (uuid-generate 'time))
		    (ruuid (uuid-generate 'random)))
		(and tuuid ruuid (uuid? tuuid) (uuid? ruuid)))
	      #t)
 (test/equal "Error in generate caught correctly"
	      (condition-case (uuid-generate 2)
			      (v () ((condition-property-accessor 'exn 'message) v)))
	      "invalid method")
 (test/eqv  "External form of uuid (1)"
	      (let ((tuuid (uuid-generate)))
		(uuid=? tuuid (uuid-parse (uuid-unparse tuuid 'lower))))
	      #t)
 (test/eqv  "External form of uuid (2)"
	      (let ((tuuid (uuid-generate)))
		(uuid=? (uuid-generate) (uuid-parse (uuid-unparse tuuid 'lower))))
	      #f)
 (test/equal  "Error in unparse caught correctly"
	      (condition-case (uuid-unparse (uuid-generate) 2)
			      (v () ((condition-property-accessor 'exn 'message) v)))
	      "invalid case")
 (test/equal  "Finalizer"
	      (condition-case (number? (gc))
			      (v () ((condition-property-accessor 'exn 'message) v)))
	      #t)
)
