;;;; uuid-lib-c-api.scm
;;;; Kon Lovett, Mar '07
;;;; BSD

;;; C API Chicken wrapper for Theodore Y. Ts'o OSF DCE 1.1 UUID Suite
(module uuid-lib-c-api
  (export
   uuidlibC$sizeof-uuid
   uuidlibC$length-uuid-string
   uuidlibC$uuid_is_null
   uuidlibC$uuid_compare
   uuidlibC$uuid_clear
   uuidlibC$uuid_copy
   uuidlibC$uuid_generate
   uuidlibC$uuid_generate_random
   uuidlibC$uuid_generate_time
   uuidlibC$uuid_parse
   uuidlibC$uuid_unparse
   uuidlibC$uuid_unparse_upper
   uuidlibC$uuid_unparse_lower)

(import scheme chicken foreign)

;;;

#>
#include <uuid/uuid.h>
<#

(define uuidlibC$sizeof-uuid (foreign-value "sizeof(uuid_t)" int))

(define uuidlibC$length-uuid-string 36)

(define uuidlibC$uuid_is_null
  (foreign-lambda int uuid_is_null c-pointer))

(define uuidlibC$uuid_compare
  (foreign-lambda int uuid_compare c-pointer c-pointer))

(define uuidlibC$uuid_clear
  (foreign-lambda void uuid_clear c-pointer))

(define uuidlibC$uuid_copy
  (foreign-lambda void uuid_copy c-pointer c-pointer))

(define uuidlibC$uuid_generate
  (foreign-lambda void uuid_generate c-pointer))

(define uuidlibC$uuid_generate_random
  (foreign-lambda void uuid_generate_random c-pointer))

(define uuidlibC$uuid_generate_time
  (foreign-lambda void uuid_generate_time c-pointer))

(define uuidlibC$uuid_parse
  (foreign-lambda int uuid_parse c-string c-pointer))

(define uuidlibC$uuid_unparse
  (foreign-lambda void uuid_unparse c-pointer c-pointer))

(define uuidlibC$uuid_unparse_upper
  (foreign-lambda void uuid_unparse_upper c-pointer c-pointer))

(define uuidlibC$uuid_unparse_lower
  (foreign-lambda void uuid_unparse_lower c-pointer c-pointer))

)